Home | History | Annotate | Download | only in packet-flood
      1 #!/bin/sh
      2 
      3 ################################################################################
      4 ##                                                                            ##
      5 ## Copyright (c) International Business Machines  Corp., 2006                 ##
      6 ##                                                                            ##
      7 ## This program is free software;  you can redistribute it and#or modify      ##
      8 ## it under the terms of the GNU General Public License as published by       ##
      9 ## the Free Software Foundation; either version 2 of the License, or          ##
     10 ## (at your option) any later version.                                        ##
     11 ##                                                                            ##
     12 ## This program is distributed in the hope that it will be useful, but        ##
     13 ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
     14 ## or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   ##
     15 ## for more details.                                                          ##
     16 ##                                                                            ##
     17 ## You should have received a copy of the GNU General Public License          ##
     18 ## along with this program;  if not, write to the Free Software               ##
     19 ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA    ##
     20 ##                                                                            ##
     21 ##                                                                            ##
     22 ################################################################################
     23 #
     24 # File:
     25 #   mcast4-pktfld01
     26 #
     27 # Description:
     28 #   Verify that the kernel is not crashed when joining a IPv4 multicast group
     29 #   a single socket, then receiving a large number of UDP packets at the socket
     30 #
     31 # Setup:
     32 #   See ltp-yyyymmdd/testcases/network/stress/README
     33 #
     34 # Author:
     35 #   Mitsuru Chinen <mitch (at] jp.ibm.com>
     36 #
     37 # History:
     38 #	May 1 2006 - Created (Mitsuru Chinen)
     39 #
     40 #-----------------------------------------------------------------------
     41 # Uncomment line below for debug output.
     42 #trace_logic=${trace_logic:-"set -x"}
     43 $trace_logic
     44 
     45 # The test case ID, the test case count and the total number of test case
     46 TCID=mcast4-pktfld01
     47 TST_TOTAL=1
     48 TST_COUNT=1
     49 export TCID
     50 export TST_COUNT
     51 export TST_TOTAL
     52 
     53 # Make sure the value of LTPROOT
     54 LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
     55 export LTPROOT
     56 
     57 # Check the environmanet variable
     58 . check_envval || exit $TST_TOTAL
     59 
     60 # Dulation of the test [sec]
     61 NS_DURATION=${NS_DURATION:-3600}      # 1 hour
     62 
     63 # The number of the test link where tests run
     64 LINK_NUM=${LINK_NUM:-0}
     65 
     66 # Network portion of the IPv4 address
     67 NETWORK_PART=${IPV4_NETWORK:-"10.0.0"}
     68 
     69 # Netmask of the IPv4 network
     70 NETWORK_MASK=24
     71 
     72 # Host portion of the IPv4 address
     73 LHOST_HOST_PART=${LHOST_IPV4_HOST:-"2"}     # local host
     74 RHOST_HOST_PART=${RHOST_IPV4_HOST:-"1"}     # remote host
     75 
     76 # Multicast Address
     77 MCAST_ADDR=224.10.0.1
     78 
     79 
     80 #-----------------------------------------------------------------------
     81 #
     82 # Function: do_cleanup
     83 #
     84 # Description:
     85 #   Recover the system configuration
     86 #
     87 #-----------------------------------------------------------------------
     88 do_cleanup()
     89 {
     90     # Make sure to kill the multicast receiver and sender
     91     killall -SIGHUP ns-mcast_receiver >/dev/null 2>&1
     92     $LTP_RSH $RHOST killall -SIGHUP ns-udpsender >/dev/null 2>&1
     93 
     94     # Clean up each interface
     95     initialize_if lhost ${LINK_NUM}
     96     initialize_if rhost ${LINK_NUM}
     97 }
     98 
     99 
    100 #-----------------------------------------------------------------------
    101 #
    102 # Function: do_setup
    103 #
    104 # Description:
    105 #   Configure the ssystem for the test
    106 #
    107 #-----------------------------------------------------------------------
    108 do_setup()
    109 {
    110     # Initialize the system configuration
    111     do_cleanup
    112 
    113     # Call do_cleanup function before exit
    114     trap do_cleanup 0
    115 
    116     # Unset the maximum number of processes
    117     ulimit -u unlimited
    118 
    119     # name of interface of the local/remote host
    120     lhost_ifname=`get_ifname lhost $LINK_NUM`
    121     if [ $? -ne 0 ]; then
    122 	tst_resm TBROK "Failed to get the interface name at the local host"
    123 	exit $TST_TOTAL
    124     fi
    125 
    126     rhost_ifname=`get_ifname rhost $LINK_NUM`
    127     if [ $? -ne 0 ]; then
    128 	tst_resm TBROK "Failed to get the interface name at the remote host"
    129 	exit $TST_TOTAL
    130     fi
    131 
    132     # Set IPv4 addresses to the interfaces
    133     set_ipv4addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
    134     if [ $? -ne 0 ]; then
    135 	tst_resm TBROK "Failed to add any IP address at the local host"
    136 	exit 1
    137     fi
    138 
    139     set_ipv4addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
    140     if [ $? -ne 0 ]; then
    141 	tst_resm TBROK "Failed to add any IP address at the remote host"
    142 	exit 1
    143     fi
    144 
    145     # IPv4 address of the local/remote host
    146     lhost_addr="${NETWORK_PART}.${LHOST_HOST_PART}"
    147     rhost_addr="${NETWORK_PART}.${RHOST_HOST_PART}"
    148 
    149     # Make sure the connectvity
    150     check_icmpv4_connectivity $lhost_ifname $rhost_addr
    151     if [ $? -ne 0 ]; then
    152 	tst_resm TBROK "There is no IPv4 connectivity."
    153 	exit 1
    154     fi
    155 
    156     # Make sure the sysctl values
    157     sysctl -w net.ipv4.igmp_max_memberships=20 >/dev/null
    158     if [ $? -ne 0 ]; then
    159 	tst_resm TBROK "Failed to set the sysctl value regarding multicast"
    160 	exit $TST_TOTAL
    161     fi
    162 
    163     sysctl -w net.ipv4.igmp_max_msf=10 >/dev/null
    164     sysctl -w net.ipv4.conf.${lhost_ifname}.force_igmp_version=0 >/dev/null
    165     sysctl -w net.ipv4.conf.all.force_igmp_version=0 >/dev/null
    166 }
    167 
    168 
    169 #-----------------------------------------------------------------------
    170 #
    171 # Main
    172 #
    173 #
    174 
    175 # Test description
    176 tst_resm TINFO "Verify that the kernel is not crashed when joining a IPv4 multicast group a single socket, then receiving a large number of UDP packets at the socket in $NS_DURATION [sec]"
    177 
    178 do_setup
    179 
    180 # Find the available consecutive ports
    181 mcast_port=`find_portbundle udp 1025 1`
    182 if [ $? -ne 0 ]; then
    183     tst_resm TBROK "No port is available."
    184     exit 1
    185 fi
    186 
    187 # Run a receiver
    188 ns-mcast_receiver -f 4 -I $lhost_ifname -m $MCAST_ADDR -p $mcast_port -b
    189 if [ $? -ne 0 ]; then
    190     tst_resm TBROK "Failed to start multicast receiver"
    191     exit 1
    192 fi
    193 
    194 # Run a sender
    195 ret=`$LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-udpsender -D $MCAST_ADDR -f 4 -p $mcast_port -s 32767 -m -I $rhost_ifname -t $NS_DURATION' ; echo $?'`
    196 if [ $ret -ne 0 ]; then
    197     tst_resm TBROK "Failed to start multicast sender"
    198     exit 1
    199 fi
    200 
    201 #-----------------------------------------------------------------------
    202 #
    203 # Clean up
    204 #
    205 
    206 tst_resm TPASS "Test is finished successfully."
    207 exit 0
    208